searchNodes=[{"doc":"CFSync is an Elixir client for Contentful sync API . Features Provides functions to extract field values from Contentful entries JSON payloads. Maps Contenful entries, assets, and links to Elixir structs. Using structs is better for readability, performance and reliability. Maps RichText data to Elixir structs. Keeps a cache of your entries and assets in a ETS table. This allows for fast (way faster than rest API calls) and concurrent reads. Keeps this cache up to date by regularly fetching changes from Contentful sync API Installation Add :cf_sync to your mix.exs dependencies. def deps do [ { :cf_sync , &quot;~&gt; 0.1.0&quot; } , ] end Basic usage # Define your fields mappings, one per content-type defmodule MyApp.PageFields do @behaviour CFSync.Entry.Fields import CFSync.Entry.Extractors defstruct :name , :body , :author # See CFSync.Entry.Extractors for extract_* documentation def new ( data ) do % __MODULE__ { name : extract_binary ( data , &quot;name&quot; ) , body : extract_richtext ( data , &quot;body&quot; ) , author : extract_link ( data , &quot;author&quot; ) , } end end # Define a mapping to map Contentful &quot;contentType&quot; ids to an atom name and a fields struct: entries_mapping = %{ # &quot;page&quot; key is the content_type ID as configured in Contentful &quot;page&quot; =&gt; %{ content_type : :page , fields_module : MyApp.PageFields , } , &quot;author&quot; =&gt; %{ content_type : :author , fields_module : MyApp.AuthorFields , } # ... } # Start a CFSync process { :ok , pid } = CFSync . start_link ( MyApp.MyCFSync , &quot;Your_contentful_space_id&quot; , &quot;Your_contentful_delivery_api_token&quot; , entries_mapping ) # Use it store = CFSync . from ( MyApp.MyCFSync ) entry = CFSync . get_entry ( store , &quot;entry_id&quot; ) # entry -&gt; % CFSync.Entry { id : &quot;entry_id&quot; , content_type : :page , fields : % MyApp.PageFields { name : &quot;Lorem ipsum&quot; , body : % CFSync.RichText { #... }, author : % CFSync.Link { id : &quot;autor_id&quot; , #... }, # ... } } author = CFSync . get_link_target ( store , entry . fields . author ) # author -&gt; % CFSync.Entry { id : &quot;author_id&quot; , content_type : :author , fields : % MyApp.AuthorFields { # ... } } !! Put your API token and space_id in your ENV, NOT in your code. You should start the CFSync process in a supervision tree .","ref":"CFSync.html","title":"CFSync","type":"module"},{"doc":"Get the CFSync store for name . Use the name your provided to start_link/4 . store = CFSync . from ( MyApp.MyCFSync ) get_entries ( store ) get_entry ( store , &quot;an_entry_id&quot; ) # ...","ref":"CFSync.html#from/1","title":"CFSync.from/1","type":"function"},{"doc":"Get the asset specified by id from the CFSync store store . Returns nil if the asset is not found.","ref":"CFSync.html#get_asset/2","title":"CFSync.get_asset/2","type":"function"},{"doc":"Returns a list containg all assets from the CFSync store store . See get_entries/1 about performance.","ref":"CFSync.html#get_assets/1","title":"CFSync.get_assets/1","type":"function"},{"doc":"Returns a list containg all entries from the CFSync store store . This function will retrieve ALL entries currently stored in the store's ETS table and deep copy them to the current process. Using this on a large Contentful space will be slow. If you want to retrieve all the entries to filter them, consider using something like memoize to cache the results.","ref":"CFSync.html#get_entries/1","title":"CFSync.get_entries/1","type":"function"},{"doc":"Returns a list containg all entries of specified content_type from the CFSync store store . See get_entries/1 about performance.","ref":"CFSync.html#get_entries_for_content_type/2","title":"CFSync.get_entries_for_content_type/2","type":"function"},{"doc":"Get the entry specified by id from the CFSync store store .","ref":"CFSync.html#get_entry/2","title":"CFSync.get_entry/2","type":"function"},{"doc":"Resolves link in the CFSync store store and returns the corresponding asset or entry. Returns nil if link target is not not found.","ref":"CFSync.html#get_link_target/2","title":"CFSync.get_link_target/2","type":"function"},{"doc":"Starts CFSync GenServer Should be started in a supervision tree name is an atom to reference this CFSync process. Use the same name in from/1 to query entries. space_id is your Contentful space's ID delivery_token is your Contentful API token content_types is a map describing how to map Contentful entries to elixir structs. See module doc. Options :locale - The locale you want to fetch from Contentful. Defaults to &quot;en-US&quot; :root_url - Default is &quot;https://cdn.contentful.com/&quot; :initial_sync_interval - The server will wait for this interval between two page requests during initial sync. Defaults to 30 milliseconds. :delta_sync_interval - The server will wait for this interval between two sync requests. Defaults to 5000 milliseconds. You can use a shorter delay to get updates faster, but you will be rate limited by Contentful if you set it too short. :invalidation_callbacks - List of 0-arity anonymous functions that will be called after each sync operation that actually adds, updates or deletes some entries.","ref":"CFSync.html#start_link/5","title":"CFSync.start_link/5","type":"function"},{"doc":"Reference to a CFSync store.","ref":"CFSync.html#t:store/0","title":"CFSync.store/0","type":"opaque"},{"doc":"The Asset struct holds data from Contentful assets. It's provided as is and is not configurable, so if you need more fields than those currently mapped, feel free to send a PR.","ref":"CFSync.Asset.html","title":"CFSync.Asset","type":"module"},{"doc":"","ref":"CFSync.Asset.html#t:t/0","title":"CFSync.Asset.t/0","type":"type"},{"doc":"The Entry struct holds standard data from Contentful entries. It's provided as is and is not configurable, so if you need more fields than those currently mapped, feel free to send a PR.","ref":"CFSync.Entry.html","title":"CFSync.Entry","type":"module"},{"doc":"","ref":"CFSync.Entry.html#t:t/0","title":"CFSync.Entry.t/0","type":"type"},{"doc":"Utility functions to extract data from contenful JSON.","ref":"CFSync.Entry.Extractors.html","title":"CFSync.Entry.Extractors","type":"module"},{"doc":"Returns value of field_name as an atom . data is the entry's payload as provided to CFSync.Entry.Fields.new/1 field_name is the field's id in Contentful (ie. What is configured in Contentful app) mapping is a map of &quot;value&quot; =&gt; :atom used to find which atom correspond to the field's value Returns default on failure (field empty, no mapping...)","ref":"CFSync.Entry.Extractors.html#extract_atom/4","title":"CFSync.Entry.Extractors.extract_atom/4","type":"function"},{"doc":"Returns value of field_name as a binary . data is the entry's payload as provided to CFSync.Entry.Fields.new/1 field_name is the field's id in Contentful (ie. What is configured in Contentful app) Returns default on failure (field empty, not a string...)","ref":"CFSync.Entry.Extractors.html#extract_binary/3","title":"CFSync.Entry.Extractors.extract_binary/3","type":"function"},{"doc":"Returns value of field_name as a boolean . data is the entry's payload as provided to CFSync.Entry.Fields.new/1 field_name is the field's id in Contentful (ie. What is configured in Contentful app) Returns default on failure (field empty, not a boolean...)","ref":"CFSync.Entry.Extractors.html#extract_boolean/3","title":"CFSync.Entry.Extractors.extract_boolean/3","type":"function"},{"doc":"Returns value of field_name as a Date . data is the entry's payload as provided to CFSync.Entry.Fields.new/1 field_name is the field's id in Contentful (ie. What is configured in Contentful app) Returns default on failure (field empty, invalid format, invalid date...)","ref":"CFSync.Entry.Extractors.html#extract_date/3","title":"CFSync.Entry.Extractors.extract_date/3","type":"function"},{"doc":"Returns value of field_name as a DateTime . data is the entry's payload as provided to CFSync.Entry.Fields.new/1 field_name is the field's id in Contentful (ie. What is configured in Contentful app) Returns default on failure (field empty, invalid format, invalid datetime...)","ref":"CFSync.Entry.Extractors.html#extract_datetime/3","title":"CFSync.Entry.Extractors.extract_datetime/3","type":"function"},{"doc":"Returns value of field_name as a CFSync.Link . data is the entry's payload as provided to CFSync.Entry.Fields.new/1 field_name is the field's id in Contentful (ie. What is configured in Contentful app) Returns default on failure (field empty, not a link...)","ref":"CFSync.Entry.Extractors.html#extract_link/3","title":"CFSync.Entry.Extractors.extract_link/3","type":"function"},{"doc":"Returns value of field_name as a list of CFSync.Link . data is the entry's payload as provided to CFSync.Entry.Fields.new/1 field_name is the field's id in Contentful (ie. What is configured in Contentful app) Returns default on failure (field empty, not a list...)","ref":"CFSync.Entry.Extractors.html#extract_links/3","title":"CFSync.Entry.Extractors.extract_links/3","type":"function"},{"doc":"Returns value of field_name as a list . data is the entry's payload as provided to CFSync.Entry.Fields.new/1 field_name is the field's id in Contentful (ie. What is configured in Contentful app) Returns default on failure (field empty, not a list...)","ref":"CFSync.Entry.Extractors.html#extract_list/3","title":"CFSync.Entry.Extractors.extract_list/3","type":"function"},{"doc":"Returns value of field_name as a map . data is the entry's payload as provided to CFSync.Entry.Fields.new/1 field_name is the field's id in Contentful (ie. What is configured in Contentful app) Returns default on failure (field empty, not a map...)","ref":"CFSync.Entry.Extractors.html#extract_map/3","title":"CFSync.Entry.Extractors.extract_map/3","type":"function"},{"doc":"Returns value of field_name as a number . data is the entry's payload as provided to CFSync.Entry.Fields.new/1 field_name is the field's id in Contentful (ie. What is configured in Contentful app) Be careful with the result as it can be either an integer or float, depending of it's value. A contentful decimal value of 1.0 will be stored as 1 in the JSON and read as an integer by JASON. Returns default on failure (field empty, not a number...)","ref":"CFSync.Entry.Extractors.html#extract_number/3","title":"CFSync.Entry.Extractors.extract_number/3","type":"function"},{"doc":"Returns value of field_name as CFSync.RichText tree. data is the entry's payload as provided to CFSync.Entry.Fields.new/1 field_name is the field's id in Contentful (ie. What is configured in Contentful app) Returns default on failure (field empty, not a richtext...)","ref":"CFSync.Entry.Extractors.html#extract_rich_text/3","title":"CFSync.Entry.Extractors.extract_rich_text/3","type":"function"},{"doc":"Entry's payload as provided to CFSync.Entry.Fields.new/1","ref":"CFSync.Entry.Extractors.html#t:data/0","title":"CFSync.Entry.Extractors.data/0","type":"opaque"},{"doc":"behaviour for fields struct. For each Contentful content-type you want to map in your Elixir app, you have to provide an Elixir module implementing this behaviour.","ref":"CFSync.Entry.Fields.html","title":"CFSync.Entry.Fields","type":"behaviour"},{"doc":"Called at struct creation. When creating an entry, CFSync will call this function with entry's data as first argument. Your implementation must return a struct implementing the CFSync.Entry.Fields protocol. The struct must be build using the extract_* functions provided by CFSync.Entry.Extractors You must configure your fields struct in config.exs, see CFSync . Example defmodule MyApp.PageFields do alias CFSync.Entry @behaviour Entry.Fields import Entry.Extractors defstruct :name , :body , :author def new ( data ) do % __MODULE__ { # field_name: extract_*(data, &quot;fieldNameInContentful&quot;, default_value \\\\ nil) name : extract_binary ( data , &quot;name&quot; , &quot;Default name&quot; ) , body : extract_richtext ( data , &quot;body&quot; ) , author : extract_link ( data , &quot;author&quot; ) , } end end","ref":"CFSync.Entry.Fields.html#c:new/1","title":"CFSync.Entry.Fields.new/1","type":"callback"},{"doc":"","ref":"CFSync.Entry.Fields.html#t:t/0","title":"CFSync.Entry.Fields.t/0","type":"type"},{"doc":"The Link struct holds data from Contentful links. It's provided as is and is not configurable, so if you need more fields than those currently mapped, feel free to send a PR. Links are used in Contentful for relations. A single-entry or single-asset relation field will contain a Link struct (or nil ). Multi-entry and multi-asset relation fields contain a list of Link structs (or [] ). Links can be resolved through CFSync.get_link_target/2 .","ref":"CFSync.Link.html","title":"CFSync.Link","type":"module"},{"doc":"","ref":"CFSync.Link.html#new/1","title":"CFSync.Link.new/1","type":"function"},{"doc":"","ref":"CFSync.Link.html#t:t/0","title":"CFSync.Link.t/0","type":"type"},{"doc":"RichText recursive struct RichText in Contentful is implemented as a tree of nodes. All nodes share a common structure and some of them have specific properties. Here I chosed to represent all nodes with a single struct for simplicity.","ref":"CFSync.RichText.html","title":"CFSync.RichText","type":"module"},{"doc":"","ref":"CFSync.RichText.html#new/1","title":"CFSync.RichText.new/1","type":"function"},{"doc":"","ref":"CFSync.RichText.html#t:marks/0","title":"CFSync.RichText.marks/0","type":"type"},{"doc":"","ref":"CFSync.RichText.html#t:node_types/0","title":"CFSync.RichText.node_types/0","type":"type"},{"doc":"","ref":"CFSync.RichText.html#t:t/0","title":"CFSync.RichText.t/0","type":"type"}]